import pyqtgraph as pg
from pyqtgraph.Qt import QtGui
import numpy
import harkbasenode


class HarkNode(harkbasenode.HarkBaseNode):
    def __init__(self):
        self.outputNames = ("OUTPUT",)
        self.outputTypes = ("prim_int",)

        self.showwave = None
        self.wavelen = 22050
        self.max = 100

        self.app = QtGui.QApplication([])
        self.app.quitOnLastWindowClosed()

        self.main = QtGui.QMainWindow()
        self.main.setWindowTitle("HARK Python Waveform")
        self.main.resize(800, 200)

        self.cwidget = QtGui.QWidget()
        self.main.setCentralWidget(self.cwidget)
        self.layout = QtGui.QVBoxLayout()
        self.cwidget.setLayout(self.layout)
        self.sitem = []
        self.main.show()

    def calculate(self):
        self.outputValues["OUTPUT"] = 0

        if self.showwave is None:
            self.showwave = numpy.array(self.WAVE)
        else:
            self.showwave = numpy.concatenate(
                (self.showwave, self.WAVE), axis=1)

        # setup layout on beginning
        if self.count == 0:
            print self.showwave.shape
            for ch in range(self.showwave.shape[0]):
                self.swidget = pg.PlotWidget(name="waveform ch" + str(ch))
                self.sitem.append(self.swidget.getPlotItem())
                self.sitem[-1].setMouseEnabled(y=False)
                self.sitem[-1].setXRange(0, self.wavelen)

                self.saxis = self.sitem[-1].getAxis("bottom")
                self.saxis.setLabel("Time [sample]")
                #self.saxis.setScale()
                self.layout.addWidget(self.swidget)

        if self.count % 5 == 0:
            if self.showwave.shape[1] > self.wavelen:
                self.showwave = self.showwave[
                    :, len(self.showwave)-self.wavelen:]

            if self.showwave.max() > self.max:
                self.max = self.showwave.max()
            for ch in range(self.showwave.shape[0]):
                self.sitem[ch].setYRange(-self.max, self.max)
                self.sitem[ch].plot(self.showwave[ch, :], clear=True)
            QtGui.QApplication.processEvents()

if __name__ == "__main__":
    import cProfile
    for i in range(5):
        calculate(i, numpy.zeros((3, 512)))
