import numpy
import pylab
import harkbasenode


class HarkNode(harkbasenode.HarkBaseNode):
    def __init__(self):
        self.outputNames = ("OUTPUT",)
        self.outputTypes = ("prim_int",)

        self.isFirst = True
        self.specgram = []
        self.winlen = 300
        pylab.ion()
        pylab.hold(False)

    def calculate(self):
        self.FFT = numpy.array(self.FFT)
        self.specgram.append(abs(self.FFT[0, :]))

        if self.count % 50 == 0:
            if len(self.specgram) > self.winlen:
                self.specgram = self.specgram[len(self.specgram)-self.winlen:]

            pylab.imshow(pylab.flipud(numpy.array(self.specgram).transpose()))

            if self.isFirst:
                pylab.colorbar()
                self.isFirst = False
            pylab.xlim([0, self.winlen])
            pylab.xticks(range(0, self.winlen, 50),
                         range(self.count - self.winlen, self.count, 50))
            pylab.xlabel("Time [frame]")
            pylab.ylabel("Frequency bin")
            pylab.draw()

        self.outputValues["OUTPUT"] = 0

    def __del__(self):
        pylab.close()
