import matplotlib.pyplot as plt
import matplotlib
import numpy
import harkbasenode
import time


class HarkNode(harkbasenode.HarkBaseNode):
    def __init__(self):
        self.outputNames = ("OUTPUT",)
        self.outputTypes = ("prim_int",)

        self.showwave = None
        self.wavelen = 16000 * 3
        # matplotlib.use('PDF')
        plt.ion()
        plt.hold(False)

    def calculate(self):
        self.outputValues["OUTPUT"] = 0

        if self.showwave is None:
            self.showwave = numpy.array(self.WAVE)
        else:
            self.showwave = numpy.concatenate(
                (self.showwave, self.WAVE), axis=1)

        if self.count % 100 == 0:
            if self.showwave.shape[1] > self.wavelen:
                self.showwave = self.showwave[:, len(self.showwave)-self.wavelen:]

            for ch in range(self.showwave.shape[0]):
                plt.subplot(self.showwave.shape[0], 1, ch+1)
                plt.plot(self.showwave[ch, :])
                plt.xlim([0, self.wavelen])
                plt.xticks(range(0, self.wavelen, 5000),
                           range(self.count, self.count + self.wavelen, 5000))
                plt.ylabel("Magnitude")
                mx = max(abs(self.showwave[ch, :]))
                plt.ylim([-mx, mx])

            if self.count == 0:
                plt.xlabel("Time [frame]")
            plt.draw()

    def __del__(self):
        plt.close()

if __name__ == "__main__":
    import cProfile
    for i in range(5):
        calculate(i, numpy.zeros((3, 512)))
